﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class CreateAddress : System.Web.UI.Page
{
    private WCFService.AGVIPServiceClient WCFProxy;

    protected void Page_Load(object sender, EventArgs e)
    {
        // WCF-Service Instanz erzeugen (Proxy)
        this.WCFProxy = new WCFService.AGVIPServiceClient();

        // Die Liste der Adresstabellen bei einem Postback nicht erneut erstellen
        if (!Page.IsPostBack)
        {
            // Erstellen einer Adresstabellenliste für den angemeldeten Benutzer.
            // Um die Vorlage Adresstabelle nicht auch in die Liste mit aufzulisten,
            // werden nur Adresstabellen welche nicht vom System erstellt wurden übernommen (IsSystem <> 1).
            // Sortiert soll die Liste nach den Namen der Adresstabellen angezeigt werden.
            WCFService.AddressSet[] AdressenTabellenListe = this.WCFProxy.ReadAddressSets(Session["GUID"].ToString(), "IsSystem<>1", "Name");

            // Übernahme der Adresstabellen in die DropDownListe
            foreach (WCFService.AddressSet AdressTabelle in AdressenTabellenListe)
            {
                ListItem AdresstblItem = new ListItem();
                AdresstblItem.Text = AdressTabelle.Name;
                AdresstblItem.Value = Convert.ToString(AdressTabelle.Id);
                DDLAddressSets.Items.Add(AdresstblItem);
            }
        }
    }

    protected void  CreateAddress_Click(object sender, EventArgs e)
    {
        // TextFelder der Web-Ansicht auslesen und in eine Field Variable casten
        WCFService.TextField NameFirst = new WCFService.TextField();
        NameFirst.Value = txtVorname.Text;
        NameFirst.FieldName = "NameFirst";
        WCFService.Field fldNameFirst = (WCFService.Field)NameFirst;

        WCFService.TextField NameLast = new WCFService.TextField();
        NameLast.Value = txtNachname.Text;
        NameLast.FieldName = "NameLast";
        WCFService.Field fldNameLast = (WCFService.Field)NameLast;


        // Zusammenführung der zu befüllenden Felder der neuen Adresse in einem Field Array
        WCFService.Field[] fldList = { fldNameFirst, fldNameLast };


        try
        {
            // Neue Adresse anlegen und die soeben generierte Adress Id speichern
            Session["IdAddress"] = this.WCFProxy.CreateAddress(Session["GUID"].ToString(), Convert.ToInt32(DDLAddressSets.SelectedValue), true, fldList);
        }
        catch (System.Exception ex)
        {
            // Bei einem Fehler, erzeugen wir Clientseitig eine Fehlermeldung
            Page.ClientScript.RegisterStartupScript(this.GetType(), "Fehler beim Erstellen", "alert('" + ex.Message + "');", true);
            return;
        }
    }
}