﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

// Dieses Beispiel beschreibt wie man sich korrekt über den WCF-Service abmeldet
// Dabei zu beachten ist, dass die ASP.NET-Session ebenfalls bereinigt wird.

public partial class Logoff : System.Web.UI.Page
{
    private WCFService.AGVIPServiceClient WCFProxy;

    protected void Page_Load(object sender, EventArgs e)
    {
        // WCF-Service Instanz erzeugen (Proxy)
        this.WCFProxy = new WCFService.AGVIPServiceClient();
    }

    // Zum Ausloggen wird so gut wie nie eine eigene Ansicht verwendet
    // Sie sollte daher eigentlich von jeder Web-Ansicht dem Anwender zur Verfügung stehen.
    // In dem Beispiel über einen linkButton, wie man ihn desöfteren zu sehen bekommt.
    protected void lbtnLogout_Click(object sender, EventArgs e)
    {
        // Terminierung der User Session und wechseln zu der Anmelde-Ansicht
        this.WCFProxy.Logoff(Session["GUID"].ToString());

        // ASP.NET Session bereinigen
        Session.Abandon();

        Response.Redirect("~/Logon.aspx");
    }
}