﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

// Dieses Beispiel beschreibt, wie ein Ticket von einer bestimmten Bearbeitungsstufe in eine andere bestimmte Bearbeitungsstufe verschoben wird.
// Passagen welche in vorherigen Beispielen behandelt wurden, werden nur noch als Hinweis angegeben

public partial class MoveTicket : System.Web.UI.Page
{
    private WCFService.AGVIPServiceClient WCFProxy;

    protected void Page_Load(object sender, EventArgs e)
    {
        // WCF-Service Instanz erzeugen (Proxy)
        this.WCFProxy = new WCFService.AGVIPServiceClient();

        if (!Page.IsPostBack)
        {
            // Befüllen der Adresstabellenliste siehe ReadAddresses.aspx.cs
            // ...

            // Befüllen der Projekttabellenliste siehe ReadTickets.aspx.cs
            // ...
        }
    }

    protected void btnProjectStateTo_Click(object sender, EventArgs e)
    {
        try
        {
            // Das Ticket wird nun in die eingetragene Bearbeitungsstufe verschoben und zusätzlich ein Historieneintrag erzeugt.
            this.WCFProxy.MoveTicket(   Session["GUID"].ToString(), Convert.ToInt32(DDLAddressSets.SelectedValue), Convert.ToInt32(Session["IdProjectState"]),
                                        Convert.ToInt32(DDLProjectStateTo.SelectedValue), Convert.ToInt32(Session["IdTicket"]), 
                                        "Ticket wurde verschoben aus: " + txtBearbeitungsstufe.Text + " nach: " + DDLProjectStateTo.Text);
        }
        catch (System.Exception ex)
        {
            Page.ClientScript.RegisterStartupScript(this.GetType(), "Fehler beim Verschieben", "alert('" + ex.Message + "');", true);
            return;
        }

        // Die Bearbeitungsstufe des Tickets hat sich verändert, daher passen wir den Wert in dem Feld auf der Ansicht an
        txtBearbeitungsstufe.Text = DDLProjectStateTo.Text;
    }

    protected void ReadTickets_Click(object sender, EventArgs e)
    {
        // Codebeispiel zum Laden der Adresse bzw. des Tickets siehe ReadTickets.aspx.cs
        // ...

        // Die ProjectStateId muss wie bei ReadTickets.aspx.cs beschrieben zusätzlich mit ausgelesen werden
        string[] strArrReadTicket = { "TimeTicket", "TicketDescription", "IdState" };
        WCFService.Field[] arrFields = null;
        WCFService.ProjectState PJState = null;

        // ReadTicket Funktion aus ReadTickets.aspx.cs
        // ...

        // Ausgelesenen Daten werden nun Ihren vorgesehenen Feldern auf der Ansicht zugeordnet
        for (int i = 0; i < arrFields.Length; ++i)
        {
            WCFService.Field field = arrFields[i];
            if (field.GetType() == typeof(WCFService.TextField))
            {
                // Siehe ReadTickets.aspx.cs
            }
            else if (field.GetType() == typeof(WCFService.IdField))
            {
                WCFService.IdField idField = (WCFService.IdField)field;
                try
                {
                    Session["IdProjectState"] = idField.Value;
                    PJState = this.WCFProxy.ReadProjectStateById(Session["GUID"].ToString(), idField.Value);
                }
                catch (System.Exception ex)
                {
                    Page.ClientScript.RegisterStartupScript(this.GetType(), "Fehler beim Lesen", "alert('" + ex.Message + "');", true);
                    return;
                }

                txtBearbeitungsstufe.Text = PJState.Name;
            }

            // Erstellen einer Projekttabellenliste für den angemeldeten Benutzer
            WCFService.ProjectState[] BearbeitungsstufenListe = this.WCFProxy.ReadProjectStates(Session["GUID"].ToString(), Convert.ToInt32(DDLProjects.SelectedValue), "IdAddrSet="+DDLAddressSets.SelectedValue.ToString()+ " & IdProject="+DDLProjects.SelectedValue.ToString(), "Name");

            // Übernahme der Projekttabellen in die DropDownListe
            foreach (WCFService.ProjectState Bearbeitungsstufe in BearbeitungsstufenListe)
            {
                ListItem ProjectStateItem = new ListItem();
                ProjectStateItem.Text = Bearbeitungsstufe.Name;
                ProjectStateItem.Value = Convert.ToString(Bearbeitungsstufe.Id);
                DDLProjectStateTo.Items.Add(ProjectStateItem);
            }
        }
    }
}