﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class UpdateAddress : System.Web.UI.Page
{
    private WCFService.AGVIPServiceClient WCFProxy;

    protected void Page_Load(object sender, EventArgs e)
    {
        // WCF-Service Instanz erzeugen (Proxy)
        this.WCFProxy = new WCFService.AGVIPServiceClient();
    }

    // Die Adresse welche bearbeitet werden soll, muss zuvor wie in der ReadAddresses.aspx.cs beschrieben geöffnet und für andere Benutzer gesperrt werden.
    // Danach kann über folgenden Aufruf die Adresse mit den Änderungen gespeichert werden.

    // Die aktuell geöffnete Adresse (gesperrte) soll bearbeitet werden
    protected void  SaveAddress_Click(object sender, EventArgs e)
    {
        // TextFelder der Web-Ansicht auslesen und in eine Field Variable casten
        WCFService.TextField NameFirst = new WCFService.TextField();
        NameFirst.Value = txtVorname.Text;
        NameFirst.FieldName = "NameFirst";
        WCFService.Field fldNameFirst = (WCFService.Field)NameFirst;

        WCFService.TextField NameLast = new WCFService.TextField();
        NameLast.Value = txtNachname.Text;
        NameLast.FieldName = "NameLast";
        WCFService.Field fldNameLast = (WCFService.Field)NameLast;

        WCFService.PSetField Kennzeichen = new WCFService.PSetField();
        Kennzeichen.Category = 1;


        // Zusammenführung der zu befüllenden Felder der neuen Adresse in einem Field Array
        WCFService.Field[] fldList = { fldNameFirst, fldNameLast };

        try
        {
            // Die übergebenen Felder übernehmen
            this.WCFProxy.UpdateAddress(Session["GUID"].ToString(), Convert.ToInt32(DDLAddressSets.SelectedValue), Convert.ToInt32(Session["IdAddress"].ToString()), fldList);

        }
        catch (System.Exception ex)
        {
            Page.ClientScript.RegisterStartupScript(this.GetType(), "Fehler beim Speichern", "alert('" + ex.Message + "');", true);
            return;
        }
    }
}