﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class UpdateTicket : System.Web.UI.Page
{
    private WCFService.AGVIPServiceClient WCFProxy;

    protected void Page_Load(object sender, EventArgs e)
    {
        // WCF-Service Instanz erzeugen (Proxy)
        this.WCFProxy = new WCFService.AGVIPServiceClient();
    }

    // Das Ticket welches bearbeitet werden soll, muss zuvor  wie in der ReadTickets.aspx.cs beschrieben geöffnet und für andere Benutzer gesperrt werden.
    // Danach kann über folgenden Aufruf das Ticket mit den Änderungen gespeichert werden.
    protected void SaveAddress_Click(object sender, EventArgs e)
    {
        // TextFelder der Web-Ansicht auslesen und in eine Field Variable übertragen
        WCFService.TextField TimeTicket = new WCFService.TextField();
        TimeTicket.Value = txtTimeTicket.Text;
        TimeTicket.FieldName = "TimeTicket";
        WCFService.Field fldTimeTicket = (WCFService.Field)TimeTicket;

        WCFService.TextField TicketDescription = new WCFService.TextField();
        TicketDescription.Value = txtTicketDesc.Text;
        TicketDescription.FieldName = "TicketDescription";
        WCFService.Field fldTicketDescription = (WCFService.Field)TicketDescription;


        // Zusammenführung der zu befüllenden Felder der neuen Adresse in einem Field Array
        WCFService.Field[] fldList = { fldTimeTicket, fldTicketDescription };

        try
        {
            // Die übergebenen Felder übernehmen
            this.WCFProxy.UpdateTicket(Session["GUID"].ToString(), Convert.ToInt32(DDLProjects.SelectedValue), Convert.ToInt32(Session["IdTicket"].ToString()), fldList);

            // Das Ticket bzw. die Adresse ist weiterhin gesperrt und müsste bei Bedarf wieder mit der 'UnlockAddress' Funktion freigegeben werden (siehe ReadAddresses.aspx.cs).
        }
        catch (System.Exception ex)
        {
            Page.ClientScript.RegisterStartupScript(this.GetType(), "Fehler beim Speichern", "alert('" + ex.Message + "');", true);
            return;
        }
    }
}